Package com.sas.metadata.remote

# Interface File

All Superinterfaces:
  `CMetadata`, `ContentLocation`, `DeployedDataPackage`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`, `Text`

All Known Subinterfaces:
  `ArchiveFile`

public interface File extends Text
Represents a file in the file system.

Attributes of File are:

- `IsARelativeName`
- `FileName`
- `FileExtension`

Associations of File are:

- `AssociatedCube`
- `AssociatedExternalTable`
- `AssociatedOLAPSchema`
- `Directories`
- `ScriptedConnections`

## Usage

To create an instance of this File, use the `factory` create methods.
Example: create a File with name "File_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     File myObject = (File) factory.createComplexMetadataObject(objectStore, "File_Object", MetadataObjects.FILE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDCUBE_NAME`
  Constant used for the name of the AssociatedCube association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDEXTERNALTABLE_NAME`
  Constant used for the name of the AssociatedExternalTable association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME`
  Constant used for the name of the AssociatedOLAPSchema association.
  `static final String`
  `ASSOCIATION_DIRECTORIES_NAME`
  Constant used for the name of the Directories association.
  `static final String`
  `ASSOCIATION_SCRIPTEDCONNECTIONS_NAME`
  Constant used for the name of the ScriptedConnections association.
  `static final String`
  `ATTRIBUTE_FILEEXTENSION_NAME`
  Constant used for the name of the FileExtension attribute.
  `static final String`
  `ATTRIBUTE_FILENAME_NAME`
  Constant used for the name of the FileName attribute.
  `static final String`
  `ATTRIBUTE_ISARELATIVENAME_NAME`
  Constant used for the name of the IsARelativeName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.ContentLocation

  `ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME, ASSOCIATION_FILEREFS_NAME, ASSOCIATION_REPORTS_NAME, ASSOCIATION_TSASSOCIATEDNAMESPACE_NAME, ASSOCIATION_UNITOFTIMES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `ASSOCIATION_ALIASES_NAME, ASSOCIATION_ALIASFOR_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_USEDBYPACKAGES_NAME, ASSOCIATION_USINGPACKAGES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Text

  `ASSOCIATION_ASSOCIATEDPROPERTY_NAME, ASSOCIATION_ASSOCIATEDQUERYCLAUSE_NAME, ASSOCIATION_ASSOCIATEDTRAINEDRESULT_NAME, ASSOCIATION_ASSOCIATEDTRANSFORMATION_NAME, ASSOCIATION_ASSOCIATEDTYPE_NAME, ASSOCIATION_TARGETS_NAME, ATTRIBUTE_TEXTROLE_NAME, ATTRIBUTE_TEXTTYPE_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Cube`
  `getAssociatedCube()`
  Gets the `Cube` for `AssociatedCube`
  `AssociationList`
  `getAssociatedCubes()`
  Gets the Association list of `AssociatedCubes`
  `AssociationList`
  `getAssociatedCubes(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedCubes`
  `ExternalTable`
  `getAssociatedExternalTable()`
  Gets the `ExternalTable` for `AssociatedExternalTable`
  `AssociationList`
  `getAssociatedExternalTables()`
  Gets the Association list of `AssociatedExternalTables`
  `AssociationList`
  `getAssociatedExternalTables(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedExternalTables`
  `OLAPSchema`
  `getAssociatedOLAPSchema()`
  Gets the `OLAPSchema` for `AssociatedOLAPSchema`
  `AssociationList`
  `getAssociatedOLAPSchemas()`
  Gets the Association list of `AssociatedOLAPSchemas`
  `AssociationList`
  `getAssociatedOLAPSchemas(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedOLAPSchemas`
  `AssociationList`
  `getDirectories()`
  Gets the Association list of `Directories`
  `AssociationList`
  `getDirectories(boolean fGoToServer)`
  Gets the Associationlist of `Directories`
  `String`
  `getFileExtension()`
  Gets the `String` value of `FileExtension`
  `int`
  `getFileExtensionMaxLength()`
  Gets the maximum length of `FileExtension`
  `int`
  `getFileExtensionState()`
  Gets the Metadata State of `FileExtension`
  `String`
  `getFileName()`
  Gets the `String` value of `FileName`
  `int`
  `getFileNameMaxLength()`
  Gets the maximum length of `FileName`
  `int`
  `getFileNameState()`
  Gets the Metadata State of `FileName`
  `int`
  `getIsARelativeName()`
  Gets the `int` value of `IsARelativeName`
  `int`
  `getIsARelativeNameState()`
  Gets the Metadata State of `IsARelativeName`
  `AssociationList`
  `getScriptedConnections()`
  Gets the Association list of `ScriptedConnections`
  `AssociationList`
  `getScriptedConnections(boolean fGoToServer)`
  Gets the Associationlist of `ScriptedConnections`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedCube(Cube inObject)`
  Sets the `AssociatedCubes` list 0th element to be `inObject`.
  `void`
  `setAssociatedCubes(AssociationList list)`
  Sets the `AssociatedCubes` list to be `list`.
  `void`
  `setAssociatedCubes(AssociationList list, int state)`
  Sets the `AssociatedCubes` list to be `list`.
  `void`
  `setAssociatedExternalTable(ExternalTable inObject)`
  Sets the `AssociatedExternalTables` list 0th element to be `inObject`.
  `void`
  `setAssociatedExternalTables(AssociationList list)`
  Sets the `AssociatedExternalTables` list to be `list`.
  `void`
  `setAssociatedExternalTables(AssociationList list, int state)`
  Sets the `AssociatedExternalTables` list to be `list`.
  `void`
  `setAssociatedOLAPSchema(OLAPSchema inObject)`
  Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list, int state)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setDirectories(AssociationList list)`
  Sets the `Directories` list to be `list`.
  `void`
  `setDirectories(AssociationList inObjects, int state)`
  Sets the entire Directories list to match the passed in AssociationList, sets the state of the Directories
  `void`
  `setFileExtension(String inFileExtension)`
  Sets the `FileExtension` value and sets the state to MetadataState.LOCAL.
  `void`
  `setFileExtension(String inFileExtension, int state)`
  Sets the `FileExtension` Metadata State.
  `void`
  `setFileExtensionState(int state)`
  Sets the Metadata State of `FileExtension`.
  `void`
  `setFileName(String inFileName)`
  Sets the `FileName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setFileName(String inFileName, int state)`
  Sets the `FileName` Metadata State.
  `void`
  `setFileNameState(int state)`
  Sets the Metadata State of `FileName`.
  `void`
  `setIsARelativeName(int inIsARelativeName)`
  Sets the `IsARelativeName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsARelativeName(int inIsARelativeName, int state)`
  Sets the `IsARelativeName` Metadata State.
  `void`
  `setIsARelativeName(String inIsARelativeName)`
  Sets the `IsARelativeName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsARelativeName(String inIsARelativeName, int state)`
  Sets the `IsARelativeName` value and Metadata State.
  `void`
  `setIsARelativeNameState(int state)`
  Sets the Metadata State of `IsARelativeName`.
  `void`
  `setScriptedConnections(AssociationList list)`
  Sets the `ScriptedConnections` list to be `list`.
  `void`
  `setScriptedConnections(AssociationList inObjects, int state)`
  Sets the entire ScriptedConnections list to match the passed in AssociationList, sets the state of the ScriptedConnections

  ### Methods inherited from interface com.sas.metadata.remote.ContentLocation

  `getAssociatedContentType, getAssociatedContentTypes, getAssociatedContentTypes, getFileRefs, getFileRefs, getReports, getReports, getTSAssociatedNamespace, getTSAssociatedNamespaces, getTSAssociatedNamespaces, getUnitofTimes, getUnitofTimes, setAssociatedContentType, setAssociatedContentTypes, setAssociatedContentTypes, setFileRefs, setFileRefs, setReports, setReports, setTSAssociatedNamespace, setTSAssociatedNamespaces, setTSAssociatedNamespaces, setUnitofTimes, setUnitofTimes`

  ### Methods inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `getAliases, getAliases, getAliasFor, getAliasFors, getAliasFors, getDeployedComponents, getDeployedComponents, getTableCollections, getTableCollections, getUsedByPackages, getUsedByPackages, getUsingPackages, getUsingPackages, setAliases, setAliases, setAliasFor, setAliasFors, setAliasFors, setDeployedComponents, setDeployedComponents, setTableCollections, setTableCollections, setUsedByPackages, setUsedByPackages, setUsingPackages, setUsingPackages`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

  ### Methods inherited from interface com.sas.metadata.remote.Text

  `getAssociatedProperty, getAssociatedPropertys, getAssociatedPropertys, getAssociatedQueryClause, getAssociatedQueryClauses, getAssociatedQueryClauses, getAssociatedTrainedResult, getAssociatedTrainedResults, getAssociatedTrainedResults, getAssociatedTransformation, getAssociatedTransformations, getAssociatedTransformations, getAssociatedType, getAssociatedTypes, getAssociatedTypes, getTargets, getTargets, getTextRole, getTextRoleMaxLength, getTextRoleState, getTextType, getTextTypeMaxLength, getTextTypeState, setAssociatedProperty, setAssociatedPropertys, setAssociatedPropertys, setAssociatedQueryClause, setAssociatedQueryClauses, setAssociatedQueryClauses, setAssociatedTrainedResult, setAssociatedTrainedResults, setAssociatedTrainedResults, setAssociatedTransformation, setAssociatedTransformations, setAssociatedTransformations, setAssociatedType, setAssociatedTypes, setAssociatedTypes, setTargets, setTargets, setTextRole, setTextRole, setTextRoleState, setTextType, setTextType, setTextTypeState`

- ## Field Details

  - ### ATTRIBUTE_ISARELATIVENAME_NAME

    static final String ATTRIBUTE_ISARELATIVENAME_NAME
    Constant used for the name of the IsARelativeName attribute.

    IsARelativeName: Does the FileName attribute include the full directory path information? If so, this attribute should be false.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_FILENAME_NAME

    static final String ATTRIBUTE_FILENAME_NAME
    Constant used for the name of the FileName attribute.

    FileName: The name of the file in the file system.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_FILEEXTENSION_NAME

    static final String ATTRIBUTE_FILEEXTENSION_NAME
    Constant used for the name of the FileExtension attribute.

    FileExtension: The type of the file, i.e. txt, html, bat.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDCUBE_NAME

    static final String ASSOCIATION_ASSOCIATEDCUBE_NAME
    Constant used for the name of the AssociatedCube association.

    AssociatedCube: The cube described by this file.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDEXTERNALTABLE_NAME

    static final String ASSOCIATION_ASSOCIATEDEXTERNALTABLE_NAME
    Constant used for the name of the AssociatedExternalTable association.

    AssociatedExternalTable: *Unknown*

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME

    static final String ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME
    Constant used for the name of the AssociatedOLAPSchema association.

    AssociatedOLAPSchema: The schema that is monitored by this log file.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DIRECTORIES_NAME

    static final String ASSOCIATION_DIRECTORIES_NAME
    Constant used for the name of the Directories association.

    Directories: *Unknown*

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SCRIPTEDCONNECTIONS_NAME

    static final String ASSOCIATION_SCRIPTEDCONNECTIONS_NAME
    Constant used for the name of the ScriptedConnections association.

    ScriptedConnections: *Unknown*

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `ContentLocation`
    Specified by:
      `initializeRequiredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `Text`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `ContentLocation`
    Specified by:
      `initializePredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `Text`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsARelativeName

    int getIsARelativeName() throws RemoteException
    Gets the `int` value of `IsARelativeName`
    Returns:
      The `IsARelativeName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsARelativeNameState

    int getIsARelativeNameState() throws RemoteException
    Gets the Metadata State of `IsARelativeName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileName

    String getFileName() throws RemoteException
    Gets the `String` value of `FileName`
    Returns:
      The `FileName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileNameState

    int getFileNameState() throws RemoteException
    Gets the Metadata State of `FileName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileNameMaxLength

    int getFileNameMaxLength() throws RemoteException
    Gets the maximum length of `FileName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileExtension

    String getFileExtension() throws RemoteException
    Gets the `String` value of `FileExtension`
    Returns:
      The `FileExtension`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileExtensionState

    int getFileExtensionState() throws RemoteException
    Gets the Metadata State of `FileExtension`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getFileExtensionMaxLength

    int getFileExtensionMaxLength() throws RemoteException
    Gets the maximum length of `FileExtension`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedCubes

    AssociationList getAssociatedCubes() throws RemoteException, MdException
    Gets the Association list of `AssociatedCubes`
    Returns:
      The AssociationList of `AssociatedCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedCube

    Cube getAssociatedCube() throws RemoteException, MdException
    Gets the `Cube` for `AssociatedCube`
    Returns:
      The `Cube` ( `null` if not set ) of `AssociatedCube` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedExternalTables

    AssociationList getAssociatedExternalTables() throws RemoteException, MdException
    Gets the Association list of `AssociatedExternalTables`
    Returns:
      The AssociationList of `AssociatedExternalTables` which can be of type:
      ExternalTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedExternalTable

    ExternalTable getAssociatedExternalTable() throws RemoteException, MdException
    Gets the `ExternalTable` for `AssociatedExternalTable`
    Returns:
      The `ExternalTable` ( `null` if not set ) of `AssociatedExternalTable` which can be of type:
      ExternalTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas() throws RemoteException, MdException
    Gets the Association list of `AssociatedOLAPSchemas`
    Returns:
      The AssociationList of `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchema

    OLAPSchema getAssociatedOLAPSchema() throws RemoteException, MdException
    Gets the `OLAPSchema` for `AssociatedOLAPSchema`
    Returns:
      The `OLAPSchema` ( `null` if not set ) of `AssociatedOLAPSchema` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDirectories

    AssociationList getDirectories() throws RemoteException, MdException
    Gets the Association list of `Directories`
    Returns:
      The AssociationList of `Directories` which can be of type:
      Directory
      AnalyticContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getScriptedConnections

    AssociationList getScriptedConnections() throws RemoteException, MdException
    Gets the Association list of `ScriptedConnections`
    Returns:
      The AssociationList of `ScriptedConnections` which can be of type:
      SASClientConnection
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedCubes

    AssociationList getAssociatedCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedCubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedExternalTables

    AssociationList getAssociatedExternalTables(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedExternalTables`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedExternalTables` which can be of type:
      ExternalTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedOLAPSchemas`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDirectories

    AssociationList getDirectories(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Directories`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Directories` which can be of type:
      Directory
      AnalyticContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getScriptedConnections

    AssociationList getScriptedConnections(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ScriptedConnections`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `ScriptedConnections` which can be of type:
      SASClientConnection
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setIsARelativeName

    void setIsARelativeName(int inIsARelativeName) throws RemoteException
    Sets the `IsARelativeName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsARelativeName` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsARelativeName

    void setIsARelativeName(int inIsARelativeName, int state) throws RemoteException
    Sets the `IsARelativeName` Metadata State.
    Parameters:
      `inIsARelativeName` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsARelativeName

    void setIsARelativeName(String inIsARelativeName) throws RemoteException
    Sets the `IsARelativeName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsARelativeName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsARelativeName

    void setIsARelativeName(String inIsARelativeName, int state) throws RemoteException
    Sets the `IsARelativeName` value and Metadata State.
    Parameters:
      `inIsARelativeName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsARelativeNameState

    void setIsARelativeNameState(int state) throws RemoteException
    Sets the Metadata State of `IsARelativeName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileName

    void setFileName(String inFileName) throws RemoteException
    Sets the `FileName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inFileName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileName

    void setFileName(String inFileName, int state) throws RemoteException
    Sets the `FileName` Metadata State.
    Parameters:
      `inFileName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileNameState

    void setFileNameState(int state) throws RemoteException
    Sets the Metadata State of `FileName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileExtension

    void setFileExtension(String inFileExtension) throws RemoteException
    Sets the `FileExtension` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inFileExtension` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileExtension

    void setFileExtension(String inFileExtension, int state) throws RemoteException
    Sets the `FileExtension` Metadata State.
    Parameters:
      `inFileExtension` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFileExtensionState

    void setFileExtensionState(int state) throws RemoteException
    Sets the Metadata State of `FileExtension`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedCubes

    void setAssociatedCubes(AssociationList list) throws RemoteException
    Sets the `AssociatedCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedCubes

    void setAssociatedCubes(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedCube

    void setAssociatedCube(Cube inObject) throws RemoteException
    Sets the `AssociatedCubes` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Cube
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedExternalTables

    void setAssociatedExternalTables(AssociationList list) throws RemoteException
    Sets the `AssociatedExternalTables` list to be `list`. Objects of which can be of type:
    ExternalTable
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedExternalTables

    void setAssociatedExternalTables(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedExternalTables` list to be `list`. Objects of which can be of type:
    ExternalTable
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedExternalTable

    void setAssociatedExternalTable(ExternalTable inObject) throws RemoteException
    Sets the `AssociatedExternalTables` list 0th element to be `inObject`.
    Parameters:
      `inObject` - ExternalTable
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Objects of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Objects of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchema

    void setAssociatedOLAPSchema(OLAPSchema inObject) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
    Parameters:
      `inObject` - OLAPSchema
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDirectories

    void setDirectories(AssociationList list) throws RemoteException
    Sets the `Directories` list to be `list`. Objects of which can be of type:
    Directory
    AnalyticContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDirectories

    void setDirectories(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Directories list to match the passed in AssociationList, sets the state of the Directories
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setScriptedConnections

    void setScriptedConnections(AssociationList list) throws RemoteException
    Sets the `ScriptedConnections` list to be `list`. Objects of which can be of type:
    SASClientConnection
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setScriptedConnections

    void setScriptedConnections(AssociationList inObjects, int state) throws RemoteException
    Sets the entire ScriptedConnections list to match the passed in AssociationList, sets the state of the ScriptedConnections
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.